/***************************************************************************
 *   Copyright (C) 2011 by Jan Wagner                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
//===========================================================================
// SVN properties (DO NOT CHANGE)
//
// $Id: BeamformerTypeDefs.h 3748 2011-09-01 18:13:37Z JanWagner $
// $HeadURL: https://svn.atnf.csiro.au/difx/libraries/beamformer/trunk/src/BeamformerTypeDefs.h $
// $LastChangedRevision: 3748 $
// $Author: JanWagner $
// $LastChangedDate: 2011-09-01 20:13:37 +0200 (Thu, 01 Sep 2011) $
//
//============================================================================

#ifndef _BF_TYPEDEFS_H
#define _BF_TYPEDEFS_H

// C++ Templates too messy for current implementation, using typedefs
// to switch between double and single precision, fixed-compile modes

#include <armadillo>

#ifdef USE_SINGLE_PRECISION
   namespace bf {
      typedef arma::cx_float complex;
      typedef float real;
   }
#else
   namespace bf {
      typedef arma::cx_double complex;
      typedef double real;
   }
#endif

#endif

